commit fc56d1b63910335c3784a540e29bb4fc47bee15d
Author: Tomáš Šimandl <tomas.simandl@gmail.com>
Date:   Thu Sep 6 21:19:11 2018 +0200

    rename attributes in b2f JSON to correspond with frontend

diff --git a/documents/backend2frontend.json b/documents/backend2frontend.json
index aa7e063..7e8209a 100644
--- a/documents/backend2frontend.json
+++ b/documents/backend2frontend.json
@@ -39,8 +39,7 @@ Návrh JSONu
 				],
 				...
 			],
-			"id": <int>,					//identifikátor vrcholu - použito např. při definici odkud kam vede hrana
-			"originalId": <int>,			//identifikátor vrcholu, který byl použit před zpracováním(filtrací) v backendu
+			"id": <int>,					//identifikátor vrcholu, který byl použit před zpracováním(filtrací) v backendu
 			"text": <string>,				//text pro případné dodatečné info mimo atributy - nemusí být použito, může sloužit jako popisek vrcholu, např. když si uživatel zobrazí jeho detaily, nejdříve se zobrazí tento popisek a až pak hodnoty atributů, může sloužit i jen jako nosič informace, která nebude uživateli přístupná
 			"title": <string>,				//jméno vrcholu
 			"position": {								//obsahuje relativní pozici uzlu v grafu
@@ -55,7 +54,7 @@ Návrh JSONu
 		{
 			"subedgeInfo": [
 				{
-					"originalId": <int>,	//identifikátor hrany, který byl použit před zpracováním(filtrací) v backendu
+					"id": <int>,			//identifikátor hrany, který byl použit před zpracováním(filtrací) v backendu
 					"archetype": <int>,		//typ hrany (index v poli edgeArchetypes)
 					"attributes": [			//struktura atributu je vzdy klic - hodnota
 						[
@@ -86,8 +85,7 @@ Návrh JSONu
 
 	"groups": [											//obsahuje jednotlivé skupiny uzlů
 		{
-			"groupId": <int>,							//identifikátor skupiny
-			"id": <int>,								//identifikátor, který je jedinečný v rámci skupin i všech uzlů
+			"id": <int>,								//identifikátor skupiny
 			"name": <string>,							//název skupiny
 			"verticesId": [<int>, <int>, ...],			//original id uzlu, které jsou ve skupině
 			"verticesEdgeFromId": [<int>, <int>, ...],	//identifikátory uzlů, jejichž odchozí hrany jsou viditelné v grafu
diff --git a/sources/src/main/java/cz/zcu/kiv/offscreen/api/Graph.java b/sources/src/main/java/cz/zcu/kiv/offscreen/api/Graph.java
index c6f42ba..614d099 100644
--- a/sources/src/main/java/cz/zcu/kiv/offscreen/api/Graph.java
+++ b/sources/src/main/java/cz/zcu/kiv/offscreen/api/Graph.java
@@ -21,8 +21,8 @@ public class Graph {
 
     private List<Group> groups;
     private List<SideBar> sideBar;
-    private int selectedVertex;
-    private int selectedEdge;
+    private int highlightedVertex;
+    private int highlightedEdge;
 
     private Logger logger = Logger.getLogger(Graph.class);
 
@@ -36,8 +36,8 @@ public class Graph {
         this.possibleEnumValues = graph.getPossibleEnumValues();
         this.groups = graph.getGraphState().getGroups();
         this.sideBar = graph.getGraphState().getSideBar();
-        this.selectedVertex = graph.getGraphState().getSelectedVertex();
-        this.selectedEdge = graph.getGraphState().getSelectedEdge();
+        this.highlightedVertex = graph.getGraphState().getHighlightedVertex();
+        this.highlightedEdge = graph.getGraphState().getHighlightedEdge();
         logger.trace("EXIT");
     }
 
@@ -77,11 +77,11 @@ public class Graph {
         return sideBar;
     }
 
-    public int getSelectedVertex() {
-        return selectedVertex;
+    public int getHighlightedVertex() {
+        return highlightedVertex;
     }
 
-    public int getSelectedEdge() {
-        return selectedEdge;
+    public int getHighlightedEdge() {
+        return highlightedEdge;
     }
 }
diff --git a/sources/src/main/java/cz/zcu/kiv/offscreen/api/SideBar.java b/sources/src/main/java/cz/zcu/kiv/offscreen/api/SideBar.java
index df26bd9..b338e30 100644
--- a/sources/src/main/java/cz/zcu/kiv/offscreen/api/SideBar.java
+++ b/sources/src/main/java/cz/zcu/kiv/offscreen/api/SideBar.java
@@ -8,11 +8,11 @@ public class SideBar {
     /** Identification number of vertex or group which was generated in application. */
     private int vertexId;
     /** Indicates if related vertexes of this item have visible icon which shows relation with this item. */
-    private boolean highlighted;
+    private boolean isIconsDisplayed;
 
-    public SideBar(int vertexId, boolean highlighted) {
+    public SideBar(int vertexId, boolean isIconsDisplayed) {
         this.vertexId = vertexId;
-        this.highlighted = highlighted;
+        this.isIconsDisplayed = isIconsDisplayed;
     }
 
     public int getVertexId() {
@@ -23,11 +23,11 @@ public class SideBar {
         this.vertexId = vertexId;
     }
 
-    public boolean isHighlighted() {
-        return highlighted;
+    public boolean isIconsDisplayed() {
+        return isIconsDisplayed;
     }
 
-    public void setHighlighted(boolean highlighted) {
-        this.highlighted = highlighted;
+    public void setIconsDisplayed(boolean iconsDisplayed) {
+        this.isIconsDisplayed = iconsDisplayed;
     }
 }
diff --git a/sources/src/main/java/cz/zcu/kiv/offscreen/graph/GraphState.java b/sources/src/main/java/cz/zcu/kiv/offscreen/graph/GraphState.java
index d06a96c..413a83a 100644
--- a/sources/src/main/java/cz/zcu/kiv/offscreen/graph/GraphState.java
+++ b/sources/src/main/java/cz/zcu/kiv/offscreen/graph/GraphState.java
@@ -11,8 +11,8 @@ public class GraphState {
 
     private List<Group> groups = new ArrayList<>();
     private List<SideBar> sideBar = new ArrayList<>();
-    private int selectedVertex;
-    private int selectedEdge;
+    private int highlightedVertex;
+    private int highlightedEdge;
 
 
     public List<Group> getGroups() {
@@ -23,12 +23,12 @@ public class GraphState {
         return sideBar;
     }
 
-    public int getSelectedVertex() {
-        return selectedVertex;
+    public int getHighlightedVertex() {
+        return highlightedVertex;
     }
 
-    public int getSelectedEdge() {
-        return selectedEdge;
+    public int getHighlightedEdge() {
+        return highlightedEdge;
     }
 
     public void addGroup(Group group){
@@ -47,11 +47,11 @@ public class GraphState {
         this.sideBar.addAll(collection);
     }
 
-    public void setSelectedVertex(int selectedVertex) {
-        this.selectedVertex = selectedVertex;
+    public void setHighlightedVertex(int highlightedVertex) {
+        this.highlightedVertex = highlightedVertex;
     }
 
-    public void setSelectedEdge(int selectedEdge) {
-        this.selectedEdge = selectedEdge;
+    public void setHighlightedEdge(int highlightedEdge) {
+        this.highlightedEdge = highlightedEdge;
     }
 }
diff --git a/sources/src/main/webapp/js/graphExporter.js b/sources/src/main/webapp/js/graphExporter.js
index 5bfe8db..b6c725e 100644
--- a/sources/src/main/webapp/js/graphExporter.js
+++ b/sources/src/main/webapp/js/graphExporter.js
@@ -27,7 +27,7 @@ function GraphExporter() {
 		var sideBar = excludedNodeList.map(function(node) {
 			return {
 				id: app.utils.getUniqueId(node),
-				isHighlighted: node.isIconsDisplayed(),
+                isIconsDisplayed: node.isIconsDisplayed(),
 			};
 		});
 
@@ -51,8 +51,8 @@ function GraphExporter() {
 			possibleEnumValues: app.possibleEnumValues,
 			groups: groups,
 			sideBar: sideBar,
-			selectedVertex: app.utils.getUniqueId(highlightedVertex), // selected = highlighted
-			selectedEdge: app.utils.isUndefined(highlightedEdge) ? '' : highlightedEdge.id, // selected = highlighted
+            highlightedVertex: app.utils.getUniqueId(highlightedVertex),
+			highlightedEdge: app.utils.isUndefined(highlightedEdge) ? '' : highlightedEdge.id,
 		};
 	}
 
diff --git a/sources/src/main/webapp/js/graphLoader.js b/sources/src/main/webapp/js/graphLoader.js
index 5ec5b5c..c7fb5af 100644
--- a/sources/src/main/webapp/js/graphLoader.js
+++ b/sources/src/main/webapp/js/graphLoader.js
@@ -22,27 +22,27 @@ function GraphLoader() {
 		app.attributeTypeList = data.attributeTypes;
 		app.possibleEnumValues = data.possibleEnumValues;
 
-        var selectedNodeId;
-        var selectedNodeType;
-        if (app.utils.isDefined(data.selectedVertex)) {
-            var selectedNodeAttr = data.selectedVertex.split("-");
-            if (selectedNodeAttr.length === 2) {
-                selectedNodeType = selectedNodeAttr[0];
-                selectedNodeId = parseInt(selectedNodeAttr[1], 10);
+        var highlightedNodeId;
+        var highlightedNodeType;
+        if (app.utils.isDefined(data.highlightedVertex)) {
+            var highlightedNodeAttr = data.highlightedVertex.split("-");
+            if (highlightedNodeAttr.length === 2) {
+                highlightedNodeType = highlightedNodeAttr[0];
+                highlightedNodeId = parseInt(highlightedNodeAttr[1], 10);
             }
         }
-		var selectedEdgeId = parseInt(data.selectedEdge, 10);
+		var highlightedEdgeId = parseInt(data.highlightedEdge, 10);
 
-        var selectedNode = undefined;
-        var selectedEdge = undefined;
+        var highlightedNode = undefined;
+        var highlightedEdge = undefined;
 
         // construct vertices
 		var vertexMap = {};
 		data.vertices.forEach(function(component) {
 			var vertex = new Vertex(component);
 
-			if (selectedNodeType === 'vertex' && selectedNodeId === vertex.id ){
-				selectedNode = vertex;
+			if (highlightedNodeType === 'vertex' && highlightedNodeId === vertex.id ){
+                highlightedNode = vertex;
 			}
 
 			var position = component.position;
@@ -68,8 +68,8 @@ function GraphLoader() {
 		data.edges.forEach(function(component) {
 			var edge = new Edge(component);
 
-            if (selectedEdgeId === edge.id ){
-                selectedEdge = edge;
+            if (highlightedEdgeId === edge.id ){
+                highlightedEdge = edge;
             }
 
 			var fromNode = vertexMap[component.from];
@@ -113,8 +113,8 @@ function GraphLoader() {
 		data.groups.forEach(function(component) {
 			var group = new Group(component);
 
-			if (selectedNodeType === 'group' && selectedNodeId === group.id ){
-                selectedNode = group;
+			if (highlightedNodeType === 'group' && highlightedNodeId === group.id ){
+                highlightedNode = group;
             }
 
 			// vertices
@@ -165,7 +165,7 @@ function GraphLoader() {
 			});
 
 			if (app.utils.isDefined(node)) {
-				node.exclude(excludedNode.isHighlighted);
+				node.exclude(excludedNode.isIconsDisplayed);
 
 				app.sidebarComponent.excludedNodeListComponent.add(node);
 			}
@@ -177,12 +177,12 @@ function GraphLoader() {
 		// update status bar
 		app.sidebarComponent.statusBarComponent.setComponentCount(data.vertices.length);
 
-		if (app.utils.isDefined(selectedEdge)) {
-			selectedEdge.setHighlighted(true);
-			selectedEdge.getFrom().setHighlighted(true);
-			selectedEdge.getTo().setHighlighted(true);
+		if (app.utils.isDefined(highlightedEdge)) {
+            highlightedEdge.setHighlighted(true);
+            highlightedEdge.getFrom().setHighlighted(true);
+            highlightedEdge.getTo().setHighlighted(true);
         }
-		if (app.utils.isDefined(selectedNode)) selectedNode.setHighlightedWithNeighbours(true);
+		if (app.utils.isDefined(highlightedNode)) highlightedNode.setHighlightedWithNeighbours(true);
 	};
 
 }
\ No newline at end of file