commit 216a8f660290d0896498b91a18e5cb4172c872ae
Author: Jakub Danek <jakub.danek@yoso.fi>
Date:   Thu Oct 10 15:58:59 2019 +0200

    re #41 move enumerations from dto to domain package

diff --git a/server/src/main/java/org/danekja/ymanager/MethodSecurityConfiguration.java b/server/src/main/java/org/danekja/ymanager/MethodSecurityConfiguration.java
new file mode 100644
index 0000000..51c8917
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/MethodSecurityConfiguration.java
@@ -0,0 +1,10 @@
+package org.danekja.ymanager;
+
+import org.springframework.context.annotation.Configuration;
+import org.springframework.security.config.annotation.method.configuration.EnableGlobalMethodSecurity;
+import org.springframework.security.config.annotation.method.configuration.GlobalMethodSecurityConfiguration;
+
+@Configuration
+@EnableGlobalMethodSecurity (jsr250Enabled = true, prePostEnabled = true)
+public class MethodSecurityConfiguration extends GlobalMethodSecurityConfiguration {
+}
diff --git a/server/src/main/java/org/danekja/ymanager/SecurityConfiguration.java b/server/src/main/java/org/danekja/ymanager/SecurityConfiguration.java
deleted file mode 100644
index 9f7c574..0000000
--- a/server/src/main/java/org/danekja/ymanager/SecurityConfiguration.java
+++ /dev/null
@@ -1,57 +0,0 @@
-package org.danekja.ymanager;
-
-import org.slf4j.Logger;
-import org.slf4j.LoggerFactory;
-import org.springframework.context.annotation.Bean;
-import org.springframework.context.annotation.Configuration;
-import org.springframework.security.authentication.AuthenticationProvider;
-import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
-import org.springframework.security.authentication.dao.AbstractUserDetailsAuthenticationProvider;
-import org.springframework.security.config.annotation.web.builders.HttpSecurity;
-import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
-import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;
-import org.springframework.security.core.AuthenticationException;
-import org.springframework.security.core.userdetails.UserDetails;
-import org.springframework.security.core.userdetails.UserDetailsService;
-
-@Configuration
-@EnableWebSecurity
-public class SecurityConfiguration extends WebSecurityConfigurerAdapter {
-
-    @Override
-    protected void configure(HttpSecurity http) throws Exception {
-        http.cors()
-                .and()
-                .authorizeRequests()
-                .anyRequest().authenticated()
-                .and()
-                .httpBasic();
-    }
-
-    /**
-     * This is a dummy authentication provider which does not check password at all.
-     * <p>
-     * To be replaced with OAuth2 client
-     *
-     * @param userDetailsService
-     * @return
-     */
-    @Bean
-    public AuthenticationProvider dummyAuthManager(UserDetailsService userDetailsService) {
-        return new AbstractUserDetailsAuthenticationProvider() {
-
-            private final Logger LOG = LoggerFactory.getLogger("DummyLogger");
-
-            @Override
-            protected void additionalAuthenticationChecks(UserDetails userDetails, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
-
-            }
-
-            @Override
-            protected UserDetails retrieveUser(String username, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
-                return userDetailsService.loadUserByUsername(username);
-            }
-        };
-    }
-
-}
diff --git a/server/src/main/java/org/danekja/ymanager/WebSecurityConfiguration.java b/server/src/main/java/org/danekja/ymanager/WebSecurityConfiguration.java
new file mode 100644
index 0000000..dd6f017
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/WebSecurityConfiguration.java
@@ -0,0 +1,57 @@
+package org.danekja.ymanager;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.security.authentication.AuthenticationProvider;
+import org.springframework.security.authentication.UsernamePasswordAuthenticationToken;
+import org.springframework.security.authentication.dao.AbstractUserDetailsAuthenticationProvider;
+import org.springframework.security.config.annotation.web.builders.HttpSecurity;
+import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
+import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;
+import org.springframework.security.core.AuthenticationException;
+import org.springframework.security.core.userdetails.UserDetails;
+import org.springframework.security.core.userdetails.UserDetailsService;
+
+@Configuration
+@EnableWebSecurity
+public class WebSecurityConfiguration extends WebSecurityConfigurerAdapter {
+
+    @Override
+    protected void configure(HttpSecurity http) throws Exception {
+        http.cors()
+                .and()
+                .authorizeRequests()
+                .anyRequest().authenticated()
+                .and()
+                .httpBasic();
+    }
+
+    /**
+     * This is a dummy authentication provider which does not check password at all.
+     * <p>
+     * To be replaced with OAuth2 client
+     *
+     * @param userDetailsService
+     * @return
+     */
+    @Bean
+    public AuthenticationProvider dummyAuthManager(UserDetailsService userDetailsService) {
+        return new AbstractUserDetailsAuthenticationProvider() {
+
+            private final Logger LOG = LoggerFactory.getLogger("DummyLogger");
+
+            @Override
+            protected void additionalAuthenticationChecks(UserDetails userDetails, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
+
+            }
+
+            @Override
+            protected UserDetails retrieveUser(String username, UsernamePasswordAuthenticationToken authentication) throws AuthenticationException {
+                return userDetailsService.loadUserByUsername(username);
+            }
+        };
+    }
+
+}
diff --git a/server/src/main/java/org/danekja/ymanager/business/ApiManager.java b/server/src/main/java/org/danekja/ymanager/business/ApiManager.java
index 8a7af72..2f3396f 100644
--- a/server/src/main/java/org/danekja/ymanager/business/ApiManager.java
+++ b/server/src/main/java/org/danekja/ymanager/business/ApiManager.java
@@ -1,8 +1,8 @@
 package org.danekja.ymanager.business;
 
-import org.danekja.ymanager.domain.User;
-import org.danekja.ymanager.domain.Vacation;
+import org.danekja.ymanager.domain.*;
 import org.danekja.ymanager.dto.*;
+import org.danekja.ymanager.dto.DefaultSettings;
 import org.danekja.ymanager.repository.RequestRepository;
 import org.danekja.ymanager.repository.UserRepository;
 import org.danekja.ymanager.repository.VacationRepository;
diff --git a/server/src/main/java/org/danekja/ymanager/business/Manager.java b/server/src/main/java/org/danekja/ymanager/business/Manager.java
index 24c1bdf..165e562 100644
--- a/server/src/main/java/org/danekja/ymanager/business/Manager.java
+++ b/server/src/main/java/org/danekja/ymanager/business/Manager.java
@@ -1,5 +1,7 @@
 package org.danekja.ymanager.business;
 
+import org.danekja.ymanager.domain.RequestType;
+import org.danekja.ymanager.domain.Status;
 import org.danekja.ymanager.dto.*;
 import org.danekja.ymanager.ws.rest.RESTFullException;
 
diff --git a/server/src/main/java/org/danekja/ymanager/business/mock/ManagerMock.java b/server/src/main/java/org/danekja/ymanager/business/mock/ManagerMock.java
index 56bcd05..e431805 100644
--- a/server/src/main/java/org/danekja/ymanager/business/mock/ManagerMock.java
+++ b/server/src/main/java/org/danekja/ymanager/business/mock/ManagerMock.java
@@ -1,6 +1,10 @@
 package org.danekja.ymanager.business.mock;
 
 import org.danekja.ymanager.business.Manager;
+import org.danekja.ymanager.domain.RequestType;
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.UserRole;
+import org.danekja.ymanager.domain.VacationType;
 import org.danekja.ymanager.dto.*;
 import org.danekja.ymanager.ws.rest.RESTFullException;
 
diff --git a/server/src/main/java/org/danekja/ymanager/domain/RequestType.java b/server/src/main/java/org/danekja/ymanager/domain/RequestType.java
new file mode 100644
index 0000000..0f618c0
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/domain/RequestType.java
@@ -0,0 +1,32 @@
+package org.danekja.ymanager.domain;
+
+/**
+ * The enum {@code RequestType} represents different types of a request.
+ */
+public enum RequestType {
+    /**
+     * The request for a vacation.
+     */
+    VACATION,
+
+    /**
+     * The request for an authorization.
+     */
+    AUTHORIZATION;
+
+    /**
+     * Creates the type of a request from the provided string.
+     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
+     *
+     * @param type the string representation of the type of a request
+     * @return the value of the enum or null
+     */
+    public static RequestType getType(final String type) {
+        if (type == null || type.isEmpty()) return null;
+        try {
+            return RequestType.valueOf(type.toUpperCase());
+        } catch (final IllegalArgumentException e) {
+            return null;
+        }
+    }
+}
diff --git a/server/src/main/java/org/danekja/ymanager/domain/Status.java b/server/src/main/java/org/danekja/ymanager/domain/Status.java
new file mode 100644
index 0000000..4e709c9
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/domain/Status.java
@@ -0,0 +1,37 @@
+package org.danekja.ymanager.domain;
+
+/**
+ * The enum {@code Status} represents states of authorization and vacation approval process.
+ */
+public enum Status {
+    /**
+     * The subject of a request is accepted.
+     */
+    ACCEPTED,
+
+    /**
+     * The subject of a request is waiting for an answer.
+     */
+    PENDING,
+
+    /**
+     * The subject of a request is rejected.
+     */
+    REJECTED;
+
+    /**
+     * Creates the status from the provided string.
+     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
+     *
+     * @param status the string representation of the status
+     * @return the value of the enum or null
+     */
+    public static Status getStatus(final String status) {
+        if (status == null || status.isEmpty()) return null;
+        try {
+            return Status.valueOf(status.toUpperCase());
+        } catch (final IllegalArgumentException e) {
+            return null;
+        }
+    }
+}
diff --git a/server/src/main/java/org/danekja/ymanager/domain/User.java b/server/src/main/java/org/danekja/ymanager/domain/User.java
index 4107d5a..12f8f42 100644
--- a/server/src/main/java/org/danekja/ymanager/domain/User.java
+++ b/server/src/main/java/org/danekja/ymanager/domain/User.java
@@ -1,7 +1,5 @@
 package org.danekja.ymanager.domain;
 
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.UserRole;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 import org.springframework.security.core.GrantedAuthority;
diff --git a/server/src/main/java/org/danekja/ymanager/domain/UserRole.java b/server/src/main/java/org/danekja/ymanager/domain/UserRole.java
new file mode 100644
index 0000000..96a4673
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/domain/UserRole.java
@@ -0,0 +1,32 @@
+package org.danekja.ymanager.domain;
+
+/**
+ * The enum {@code UserRole} represents different roles of a user.
+ */
+public enum UserRole {
+    /**
+     * The user is an employee.
+     */
+    EMPLOYEE,
+
+    /**
+     * The user is na employer. This user has more rights than an employee.
+     */
+    EMPLOYER;
+
+    /**
+     * Creates the role from the provided string.
+     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
+     *
+     * @param role the string representation of the role
+     * @return the value of the enum or null
+     */
+    public static UserRole getUserRole(final String role) {
+        if (role == null || role.isEmpty()) return null;
+        try {
+            return UserRole.valueOf(role.toUpperCase());
+        } catch (final IllegalArgumentException e) {
+            return null;
+        }
+    }
+}
diff --git a/server/src/main/java/org/danekja/ymanager/domain/Vacation.java b/server/src/main/java/org/danekja/ymanager/domain/Vacation.java
index 220f55c..1ba9cc3 100644
--- a/server/src/main/java/org/danekja/ymanager/domain/Vacation.java
+++ b/server/src/main/java/org/danekja/ymanager/domain/Vacation.java
@@ -1,7 +1,5 @@
 package org.danekja.ymanager.domain;
 
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.VacationType;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 
diff --git a/server/src/main/java/org/danekja/ymanager/domain/VacationType.java b/server/src/main/java/org/danekja/ymanager/domain/VacationType.java
new file mode 100644
index 0000000..8e0774c
--- /dev/null
+++ b/server/src/main/java/org/danekja/ymanager/domain/VacationType.java
@@ -0,0 +1,32 @@
+package org.danekja.ymanager.domain;
+
+/**
+ * The enum {@code VacationType} represents different types of a vacation.
+ */
+public enum VacationType {
+    /**
+     * The vacation represents a sick day.
+     */
+    SICK_DAY,
+
+    /**
+     * The vacation represents an overtime.
+     */
+    VACATION;
+
+    /**
+     * Creates the type of a vacation from the provided string.
+     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
+     *
+     * @param type the string representation of the type of a vacation
+     * @return the value of the enum or null
+     */
+    public static VacationType getVacationType(final String type) {
+        if (type == null || type.isEmpty()) return null;
+        try {
+            return VacationType.valueOf(type.toUpperCase());
+        } catch (final IllegalArgumentException e) {
+            return null;
+        }
+    }
+}
diff --git a/server/src/main/java/org/danekja/ymanager/dto/AuthorizationRequest.java b/server/src/main/java/org/danekja/ymanager/dto/AuthorizationRequest.java
index d30828e..c380643 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/AuthorizationRequest.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/AuthorizationRequest.java
@@ -1,5 +1,7 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.Status;
+
 import java.time.LocalDateTime;
 
 /**
diff --git a/server/src/main/java/org/danekja/ymanager/dto/BasicRequest.java b/server/src/main/java/org/danekja/ymanager/dto/BasicRequest.java
index f8809bc..2f55bda 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/BasicRequest.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/BasicRequest.java
@@ -1,5 +1,7 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.Status;
+
 /**
  * An instance of the messenger class {@code BasicRequest} can represent an authorization or a vacation request.
  * The class is used for changing a status of the authorization or the vacation request when a client sends a request on an api endpoint.
diff --git a/server/src/main/java/org/danekja/ymanager/dto/FullUserProfile.java b/server/src/main/java/org/danekja/ymanager/dto/FullUserProfile.java
index 41cc823..aaa83a5 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/FullUserProfile.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/FullUserProfile.java
@@ -1,6 +1,8 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.Status;
 import org.danekja.ymanager.domain.User;
+import org.danekja.ymanager.domain.UserRole;
 
 import java.time.LocalDateTime;
 
diff --git a/server/src/main/java/org/danekja/ymanager/dto/RequestType.java b/server/src/main/java/org/danekja/ymanager/dto/RequestType.java
deleted file mode 100644
index 0002031..0000000
--- a/server/src/main/java/org/danekja/ymanager/dto/RequestType.java
+++ /dev/null
@@ -1,32 +0,0 @@
-package org.danekja.ymanager.dto;
-
-/**
- * The enum {@code RequestType} represents different types of a request.
- */
-public enum RequestType {
-    /**
-     * The request for a vacation.
-     */
-    VACATION,
-
-    /**
-     * The request for an authorization.
-     */
-    AUTHORIZATION;
-
-    /**
-     * Creates the type of a request from the provided string.
-     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
-     *
-     * @param type the string representation of the type of a request
-     * @return the value of the enum or null
-     */
-    public static RequestType getType(final String type) {
-        if (type == null || type.isEmpty()) return null;
-        try {
-            return RequestType.valueOf(type.toUpperCase());
-        } catch (final IllegalArgumentException e) {
-            return null;
-        }
-    }
-}
diff --git a/server/src/main/java/org/danekja/ymanager/dto/Status.java b/server/src/main/java/org/danekja/ymanager/dto/Status.java
deleted file mode 100644
index 9108353..0000000
--- a/server/src/main/java/org/danekja/ymanager/dto/Status.java
+++ /dev/null
@@ -1,37 +0,0 @@
-package org.danekja.ymanager.dto;
-
-/**
- * The enum {@code Status} represents states of authorization and vacation approval process.
- */
-public enum Status {
-    /**
-     * The subject of a request is accepted.
-     */
-    ACCEPTED,
-
-    /**
-     * The subject of a request is waiting for an answer.
-     */
-    PENDING,
-
-    /**
-     * The subject of a request is rejected.
-     */
-    REJECTED;
-
-    /**
-     * Creates the status from the provided string.
-     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
-     *
-     * @param status the string representation of the status
-     * @return the value of the enum or null
-     */
-    public static Status getStatus(final String status) {
-        if (status == null || status.isEmpty()) return null;
-        try {
-            return Status.valueOf(status.toUpperCase());
-        } catch (final IllegalArgumentException e) {
-            return null;
-        }
-    }
-}
diff --git a/server/src/main/java/org/danekja/ymanager/dto/UserRole.java b/server/src/main/java/org/danekja/ymanager/dto/UserRole.java
deleted file mode 100644
index a460398..0000000
--- a/server/src/main/java/org/danekja/ymanager/dto/UserRole.java
+++ /dev/null
@@ -1,32 +0,0 @@
-package org.danekja.ymanager.dto;
-
-/**
- * The enum {@code UserRole} represents different roles of a user.
- */
-public enum UserRole {
-    /**
-     * The user is an employee.
-     */
-    EMPLOYEE,
-
-    /**
-     * The user is na employer. This user has more rights than an employee.
-     */
-    EMPLOYER;
-
-    /**
-     * Creates the role from the provided string.
-     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
-     *
-     * @param role the string representation of the role
-     * @return the value of the enum or null
-     */
-    public static UserRole getUserRole(final String role) {
-        if (role == null || role.isEmpty()) return null;
-        try {
-            return UserRole.valueOf(role.toUpperCase());
-        } catch (final IllegalArgumentException e) {
-            return null;
-        }
-    }
-}
diff --git a/server/src/main/java/org/danekja/ymanager/dto/UserSettings.java b/server/src/main/java/org/danekja/ymanager/dto/UserSettings.java
index 17167cc..ef30272 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/UserSettings.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/UserSettings.java
@@ -1,5 +1,7 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.UserRole;
+
 import java.time.LocalDateTime;
 
 /**
diff --git a/server/src/main/java/org/danekja/ymanager/dto/VacationDay.java b/server/src/main/java/org/danekja/ymanager/dto/VacationDay.java
index e613537..0f35d10 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/VacationDay.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/VacationDay.java
@@ -1,5 +1,8 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.VacationType;
+
 import java.time.LocalDate;
 import java.time.LocalTime;
 
diff --git a/server/src/main/java/org/danekja/ymanager/dto/VacationRequest.java b/server/src/main/java/org/danekja/ymanager/dto/VacationRequest.java
index 7827d66..15a4f79 100644
--- a/server/src/main/java/org/danekja/ymanager/dto/VacationRequest.java
+++ b/server/src/main/java/org/danekja/ymanager/dto/VacationRequest.java
@@ -1,5 +1,8 @@
 package org.danekja.ymanager.dto;
 
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.VacationType;
+
 import java.time.LocalDate;
 import java.time.LocalDateTime;
 import java.time.LocalTime;
diff --git a/server/src/main/java/org/danekja/ymanager/dto/VacationType.java b/server/src/main/java/org/danekja/ymanager/dto/VacationType.java
deleted file mode 100644
index e7ce831..0000000
--- a/server/src/main/java/org/danekja/ymanager/dto/VacationType.java
+++ /dev/null
@@ -1,32 +0,0 @@
-package org.danekja.ymanager.dto;
-
-/**
- * The enum {@code VacationType} represents different types of a vacation.
- */
-public enum VacationType {
-    /**
-     * The vacation represents a sick day.
-     */
-    SICK_DAY,
-
-    /**
-     * The vacation represents an overtime.
-     */
-    VACATION;
-
-    /**
-     * Creates the type of a vacation from the provided string.
-     * The method is case insensitive. If the given string does not correspond to any values of the enum the method returns null.
-     *
-     * @param type the string representation of the type of a vacation
-     * @return the value of the enum or null
-     */
-    public static VacationType getVacationType(final String type) {
-        if (type == null || type.isEmpty()) return null;
-        try {
-            return VacationType.valueOf(type.toUpperCase());
-        } catch (final IllegalArgumentException e) {
-            return null;
-        }
-    }
-}
diff --git a/server/src/main/java/org/danekja/ymanager/repository/RequestRepository.java b/server/src/main/java/org/danekja/ymanager/repository/RequestRepository.java
index 9b4459c..da4b591 100644
--- a/server/src/main/java/org/danekja/ymanager/repository/RequestRepository.java
+++ b/server/src/main/java/org/danekja/ymanager/repository/RequestRepository.java
@@ -1,5 +1,7 @@
 package org.danekja.ymanager.repository;
 
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.VacationType;
 import org.danekja.ymanager.dto.*;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
diff --git a/server/src/main/java/org/danekja/ymanager/repository/UserRepository.java b/server/src/main/java/org/danekja/ymanager/repository/UserRepository.java
index 75a0b7c..d34f81e 100644
--- a/server/src/main/java/org/danekja/ymanager/repository/UserRepository.java
+++ b/server/src/main/java/org/danekja/ymanager/repository/UserRepository.java
@@ -1,6 +1,8 @@
 package org.danekja.ymanager.repository;
 
+import org.danekja.ymanager.domain.Status;
 import org.danekja.ymanager.domain.User;
+import org.danekja.ymanager.domain.UserRole;
 import org.danekja.ymanager.dto.*;
 import org.danekja.ymanager.repository.jdbc.mappers.UserRowMapper;
 import org.slf4j.Logger;
@@ -18,7 +20,7 @@ import java.util.List;
 import java.util.Map;
 import java.util.Optional;
 
-import static org.danekja.ymanager.dto.UserRole.getUserRole;
+import static org.danekja.ymanager.domain.UserRole.getUserRole;
 
 /**
  * An instance of the class UserRepository handles queries which selects and updates users and their settings in a database.
diff --git a/server/src/main/java/org/danekja/ymanager/repository/VacationRepository.java b/server/src/main/java/org/danekja/ymanager/repository/VacationRepository.java
index 9056dbf..ca47f5a 100644
--- a/server/src/main/java/org/danekja/ymanager/repository/VacationRepository.java
+++ b/server/src/main/java/org/danekja/ymanager/repository/VacationRepository.java
@@ -2,10 +2,10 @@ package org.danekja.ymanager.repository;
 
 import org.danekja.ymanager.domain.User;
 import org.danekja.ymanager.domain.Vacation;
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.UserRole;
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.UserRole;
 import org.danekja.ymanager.dto.VacationDay;
-import org.danekja.ymanager.dto.VacationType;
+import org.danekja.ymanager.domain.VacationType;
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
 import org.springframework.beans.factory.annotation.Autowired;
@@ -21,7 +21,7 @@ import java.util.List;
 import java.util.Optional;
 
 import static java.util.Optional.ofNullable;
-import static org.danekja.ymanager.dto.Status.getStatus;
+import static org.danekja.ymanager.domain.Status.getStatus;
 
 @Repository
 public class VacationRepository {
diff --git a/server/src/main/java/org/danekja/ymanager/repository/jdbc/mappers/UserRowMapper.java b/server/src/main/java/org/danekja/ymanager/repository/jdbc/mappers/UserRowMapper.java
index f9c9fdc..60b4d00 100644
--- a/server/src/main/java/org/danekja/ymanager/repository/jdbc/mappers/UserRowMapper.java
+++ b/server/src/main/java/org/danekja/ymanager/repository/jdbc/mappers/UserRowMapper.java
@@ -1,8 +1,8 @@
 package org.danekja.ymanager.repository.jdbc.mappers;
 
 import org.danekja.ymanager.domain.User;
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.UserRole;
+import org.danekja.ymanager.domain.Status;
+import org.danekja.ymanager.domain.UserRole;
 import org.springframework.jdbc.core.RowMapper;
 
 import java.sql.ResultSet;
diff --git a/server/src/main/java/org/danekja/ymanager/ws/rest/ApiController.java b/server/src/main/java/org/danekja/ymanager/ws/rest/ApiController.java
index 9b6cd4a..d156ff4 100644
--- a/server/src/main/java/org/danekja/ymanager/ws/rest/ApiController.java
+++ b/server/src/main/java/org/danekja/ymanager/ws/rest/ApiController.java
@@ -3,6 +3,8 @@ package org.danekja.ymanager.ws.rest;
 import org.apache.commons.lang3.StringUtils;
 import org.danekja.ymanager.business.FileService;
 import org.danekja.ymanager.business.Manager;
+import org.danekja.ymanager.domain.RequestType;
+import org.danekja.ymanager.domain.Status;
 import org.danekja.ymanager.dto.*;
 import org.danekja.ymanager.util.localization.Language;
 import org.springframework.beans.factory.annotation.Autowired;
diff --git a/server/src/test/java/org/danekja/ymanager/domain/UserTest.java b/server/src/test/java/org/danekja/ymanager/domain/UserTest.java
index 3c484a4..4dad2f6 100644
--- a/server/src/test/java/org/danekja/ymanager/domain/UserTest.java
+++ b/server/src/test/java/org/danekja/ymanager/domain/UserTest.java
@@ -1,7 +1,5 @@
 package org.danekja.ymanager.domain;
 
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.UserRole;
 import org.junit.jupiter.api.BeforeEach;
 import org.junit.jupiter.api.Test;
 
diff --git a/server/src/test/java/org/danekja/ymanager/domain/VacationTest.java b/server/src/test/java/org/danekja/ymanager/domain/VacationTest.java
index 137a197..9aef7ae 100644
--- a/server/src/test/java/org/danekja/ymanager/domain/VacationTest.java
+++ b/server/src/test/java/org/danekja/ymanager/domain/VacationTest.java
@@ -1,7 +1,5 @@
 package org.danekja.ymanager.domain;
 
-import org.danekja.ymanager.dto.Status;
-import org.danekja.ymanager.dto.VacationType;
 import org.junit.jupiter.api.BeforeEach;
 import org.junit.jupiter.api.Test;
 